From ade03b6c79a47628bec3fc8aa3db5bde1869a513 Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 7/32] Issues: Add tests and fix resulting errors


---

diff --git a/hubs/tests/widgets/test_issues.py b/hubs/tests/widgets/test_issues.py
new file mode 100644
index 0000000..cfb52a2
--- /dev/null
+++ b/hubs/tests/widgets/test_issues.py
@@ -0,0 +1,66 @@
+from __future__ import unicode_literals
+
+from . import WidgetTest
+
+
+class IssuesTest(WidgetTest):
+
+    plugin = "issues"
+
+    def populate(self):
+        super(IssuesTest, self).populate()
+        self._add_widget_under_test()
+
+    def test_author_should_invalidate_bugzilla(self):
+        msg = {
+            'topic': 'tests.bugzilla.bug.new',
+            'msg': {
+                'bug': {
+                    'creator': self.widget.hub.config['bugzilla_email'],
+                },
+            },
+        }
+        func = self.widget.module.get_cached_functions()['GetBugzillaBugs']
+        self.assertTrue(func(self.widget).should_invalidate(msg))
+
+    def test_author_should_invalidate_pagure(self):
+        msg = {
+            'topic': 'tests.pagure.issue.new',
+            'msg': {
+                'user': {
+                    'name': self.widget.hub.config['pagure_username'],
+                },
+            },
+        }
+        func = self.widget.module.get_cached_functions()['GetPagureIssues']
+        self.assertTrue(func(self.widget).should_invalidate(msg))
+
+    def test_assignee_should_invalidate_bugzilla(self):
+        self._update_widget_config({
+            "mode": "assignee",
+        })
+        msg = {
+            'topic': 'tests.bugzilla.bug.new',
+            'msg': {
+                'bug': {
+                    'assigned_to': self.widget.hub.config['bugzilla_email'],
+                },
+            },
+        }
+        func = self.widget.module.get_cached_functions()['GetBugzillaBugs']
+        self.assertTrue(func(self.widget).should_invalidate(msg))
+
+    def test_assignee_should_invalidate_pagure(self):
+        self._update_widget_config({
+            "mode": "assignee",
+        })
+        msg = {
+            'topic': 'tests.pagure.issue.new',
+            'msg': {
+                'assignee': {
+                    'name': self.widget.hub.config['pagure_username'],
+                },
+            },
+        }
+        func = self.widget.module.get_cached_functions()['GetPagureIssues']
+        self.assertTrue(func(self.widget).should_invalidate(msg))
diff --git a/hubs/widgets/issues/__init__.py b/hubs/widgets/issues/__init__.py
index cebd3e1..b3e8c62 100644
--- a/hubs/widgets/issues/__init__.py
+++ b/hubs/widgets/issues/__init__.py
@@ -20,6 +20,7 @@ class Issues(Widget):
         )
     ]
     is_react = True
+    cached_functions_module = ".functions"
 
     def get_props(self, instance, *args, **kwargs):
         props = super(Issues, self).get_props(instance, *args, **kwargs)
diff --git a/hubs/widgets/issues/functions.py b/hubs/widgets/issues/functions.py
index 6d79923..226ec49 100644
--- a/hubs/widgets/issues/functions.py
+++ b/hubs/widgets/issues/functions.py
@@ -28,7 +28,7 @@ class GetBugzillaBugs(CachedFunction):
         return [res, total_count]
 
     def should_invalidate(self, message):
-        email = self.instance.hub.config('bugzilla_email')
+        email = self.instance.hub.config['bugzilla_email']
         mode = self.instance.config['mode']
         if message['topic'].endswith('bugzilla.bug.new') or \
            message['topic'].endswith('bugzilla.bug.update'):
@@ -64,7 +64,7 @@ class GetPagureIssues(CachedFunction):
 
     def should_invalidate(self, message):
         mode = self.instance.config['mode']
-        username = self.instance.hub.config('pagure_username')
+        username = self.instance.hub.config['pagure_username']
         if message['topic'].endswith('pagure.issue.new') or \
            message['topic'].endswith('pagure.issue.edit') or \
            message['topic'].endswith('pagure.issue.assigned.added') or \

